<?php

namespace App\Repository;

use App\Entity\Reductions;
use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Doctrine\Persistence\ManagerRegistry;

/**
 * @extends ServiceEntityRepository<Reductions>
 */
class ReductionsRepository extends ServiceEntityRepository
{
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, Reductions::class);
    }

//    /**
//     * @return Reductions[] Returns an array of Reductions objects
//     */
//    public function findByExampleField($value): array
//    {
//        return $this->createQueryBuilder('r')
//            ->andWhere('r.exampleField = :val')
//            ->setParameter('val', $value)
//            ->orderBy('r.id', 'ASC')
//            ->setMaxResults(10)
//            ->getQuery()
//            ->getResult()
//        ;
//    }

//    public function findOneBySomeField($value): ?Reductions
//    {
//        return $this->createQueryBuilder('r')
//            ->andWhere('r.exampleField = :val')
//            ->setParameter('val', $value)
//            ->getQuery()
//            ->getOneOrNullResult()
//        ;
//    }

    public function findApplicableReductions(float $montantTotal): array
    {
        $qb = $this->createQueryBuilder('r');

        return $qb
            ->where('r.montant_min <= :montantTotal')
            ->andWhere('r.actif = :actif')
            ->andWhere('r.DateDebut <= :currentDate')
            ->andWhere('r.DateFin >= :currentDate')
            ->setParameter('montantTotal', $montantTotal)
            ->setParameter('actif', true)
            ->setParameter('currentDate', new \DateTime())
            ->getQuery()
            ->getResult();
    }
}
